//+----------------------------------------------------------+
//|                             Alternative Ichimoku .mq4    |
//|                             Copyright  february 2007    |
//|               Lukashuk Victor Gennadievich aka lukas1   
//|
//|                                lucas settings:
//| Pair         Time  SSP  SSK
//| EURGBP    4H    44     38
//| CADCHF    4H    62     52
//| CADJPY    4H    48     36
//| GBPUSD    4H    44     36
//| GBPCHF    4H    34     29
//| GBPJPY    4H    36     29
//| EURUSD    4H    34     34
//| EURCHF    4H    72     50
//| EURJPY    4H    72     36
//| USDCAD    4H    24     60
//| USDCHF    4H    34     29
//| USDJPY    4H    34     29
//| 
//+----------------------------------------------------------+
#property copyright "Copyright  2007, lukas1"
#property link ""
//----
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 LightSteelBlue
#property indicator_color2 LightPink
#property indicator_color3 LightSteelBlue
#property indicator_color4 LightPink
#property indicator_width3 2
#property indicator_width4 2
#property indicator_color5 Blue
//---- input parameters
extern ENUM_TIMEFRAMES TimeFrame  = PERIOD_CURRENT;
extern int SSP = 34; // calculating period    -  ; 
extern int SSK = 29; // tolerance of second line   ; 
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double Wal1[];
double Wal2[];
double ExtMapBuffer4[];
int i1,  i2, shift;
double SsMax, SsMin, SsMax05, SsMin05, Rsmin, Rsmax, Tsmin, Tsmax;
int val1, val2, AvgRange;
bool uptrend, old;
//----
bool gSellAlertGiven = false; // Used to stop constant alerts
bool gBuyAlertGiven  = false; // Used to stop constant alerts
string comm, st_AvgRange, st_Buy_Sell, st_text, st_level;
string indicatorFileName;
bool   returnBars;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(5);
//----
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexDrawBegin(0, SSP*2);
   SetIndexLabel(0,"priority line"); //   fast line)
//---- 
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, ExtMapBuffer2);
   SetIndexDrawBegin(1, SSP*2);
   SetIndexLabel(1,"overdue line"); //   lagging line
//---- 
   SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexBuffer(2, Wal1);
   SetIndexDrawBegin(2, SSP*2);
//---- 
   SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexBuffer(3, Wal2);
   SetIndexDrawBegin(3, SSP*2);
//---- 
   SetIndexStyle(4, DRAW_LINE);
   SetIndexBuffer(4, ExtMapBuffer4);
   SetIndexDrawBegin(4, SSP*2);
   SetIndexLabel(4, "stop-order line"); //     -
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == -99;
   TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName (timeFrameToString(TimeFrame)+" Alternate_Ichimoku");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit() 
  {
   Comment("");
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ExtMapBuffer1[0] = limit+1; return(0); }
         if (TimeFrame != Period())
         {
            limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
            for (int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,TimeFrame,Time[i]);
                  ExtMapBuffer1[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,SSP,SSK,0,y);
                  ExtMapBuffer2[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,SSP,SSK,1,y);
                  Wal1[i]          = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,SSP,SSK,2,y);
                  Wal2[i]          = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,SSP,SSK,3,y);
                  ExtMapBuffer4[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,SSP,SSK,4,y);
            }
            return(0);            
         }
   if(Bars <= SSP + 1)
       return(0);
   i = Bars - SSP;
   while(i >= 0)
     {
       // maximum of previous SSP bars period
       SsMax = High[iHighest(NULL, 0, MODE_HIGH, SSP, i)];      
       // minimum of previous SSP bars period
       SsMin = Low[iLowest(NULL, 0, MODE_LOW, SSP, i)];         
       // maximum of SSP bars period for SSK bars from begin
       SsMax05 = High[iHighest(NULL, 0, MODE_HIGH, SSP, i + SSK)];
       // maximum of SSP bars period for SSK bars from begin
       SsMin05 = Low[iLowest(NULL, 0, MODE_LOW, SSP, i + SSK)];   
       ExtMapBuffer1[i] = (SsMax + SsMin) / 2;
       ExtMapBuffer2[i] = (SsMax05+SsMin05) / 2;
       val1 = ExtMapBuffer1[1] / Point;
       val2 = ExtMapBuffer2[1] / Point;
       //----
       Rsmax = High[iHighest(NULL, 0, MODE_HIGH, SSP*2, i)]; 
       Rsmin = Low[iLowest(NULL, 0, MODE_LOW, SSP*2, i)];  
       AvgRange = (Rsmax / Point) - (Rsmin / Point);
       Wal1[i] = ExtMapBuffer1[i];
       Wal2[i] = ExtMapBuffer2[i];
       //----
       Tsmax = High[iHighest(NULL, 0, MODE_HIGH, SSP*1.62, i)];     
       Tsmin = Low[iLowest(NULL, 0, MODE_LOW, SSP*1.62, i)];    
       ExtMapBuffer4[i] = (Tsmax + Tsmin) / 2;     
       i--;
     } 
   st_AvgRange=AvgRange;
   comm = "  volatility:  " + st_AvgRange + " pips" + "\n";         
   Comment(comm);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}